/*
 * Copyright (C) 2006-2007	Andre Beckedorf
 * 					 		<evilJazz _AT_ katastrophos _DOT_ net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef PLAYLISTOVERVIEW_H_INCLUDED
#define PLAYLISTOVERVIEW_H_INCLUDED

#include <QShowEvent>
#include <QEvent>
#include <QLabel>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QListView>

#include "skinmanager.h"
#include "playlistview.h"
#include "playlistaspectoverviewfilter.h"

class QWidget;
class QLabel;

class PlayListOverview: public QWidget
{
    Q_OBJECT
public:
    PlayListOverview(QWidget *parent = 0);
    virtual ~PlayListOverview();

    void attachTo(PlayListAspectOverviewFilter *source);
    void detach();
    PlayListAspectOverviewFilter *aspectSource() { return aspectSource_; }

    void setSkinMode(const SkinModeInformation &modeInfo);

    QListView::SelectionMode selectionMode() { return genreListBox_->selectionMode(); }
    void setSelectionMode(QListView::SelectionMode mode);

signals:
    void focusOutLeft();
    void focusOutRight();

protected:
    void showEvent(QShowEvent *);
    void hideEvent(QHideEvent *);
    bool eventFilter(QObject *, QEvent *);

private:
    MediaDatabase *mediaDatabase_;
    PlayListAspectOverviewFilter *aspectSource_;

    bool isDirty_;

    QVBoxLayout *genreBox_;
    QVBoxLayout *artistBox_;
    QVBoxLayout *albumBox_;

    QLabel *genreHeading_;
    QLabel *artistHeading_;
    QLabel *albumHeading_;

    QListView *genreListBox_;
    QListView *artistListBox_;
    QListView *albumListBox_;

    void createColumnBox(QString title, QVBoxLayout *&box, QLabel *&heading, QListView *&listbox);
};

#endif // PLAYLISTOVERVIEW_H_INCLUDED
